unit TxDataIO;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

function TXDataOut(hWndTx: HWND): string;
procedure TXDataIn(hWndTx: HWND; sData: string);


type
  TDataModule2 = class(TDataModule)

  private

  public
    { Public-Deklarationen }
  end;

var
  DataModule2: TDataModule2;

implementation

{$R *.DFM}

const
   TX_DATAIN		    = WM_USER+1024;
   TX_DATAOUT		    = WM_USER+1025;

   TF_FORMAT_AUTO	    = $0001;
   TF_FORMAT_USER	    = $0002;
   TF_FORMAT_TEXT	    = $0003;
   TF_FORMAT_ANSI	    = $0004;
   TF_FORMAT_TX       = $0005;
   TF_FORMAT_HTML	    = $0006;
   TF_FORMAT_RTF		 = $0007;

type
  TPTxDataIO     = ^TTxDataIO;
  TTxDataIO      = packed record
                     wTXVersion         : word;         // curr. Text Control version
                     hFile              : hfile;        // file handle
                     lpFileName         : PChar;        // file name incl. path hFile belongs to
                     hpInBuffer         : pointer;      // pointer to mem. alternative to hFile
                     hOutBuffer         : hglobal;      // mem. buffer with output data
                     wFormat            : word;	        // format id
                     lpFilterName       : PChar;        // filter name incl. path alternative to wFormat
                     bCurSelection      : bool;	        // handle curr. selection or compl. contents
                     ptMinSize          : TPoint;       // retrieves minimum Text Control size
                     dwBytesReadWritten : dword;        // read or written bytes
                     lReserved          : integer;      // for future use
                     lpFilterIO         : pointer       // change to TPTxFilterIO when needed
                   end;


// ----------------------------------------------------------------------------
// TXDataOut
//
// Return the contents of the Text Control specified in hWndTx as a string.
// ----------------------------------------------------------------------------
function TXDataOut(hWndTx: HWND): string;
var
   io: TTxDataIO;
   p: PChar;
begin
   io.wTXVersion := 500;
   io.hFile := HFILE_ERROR;
   io.lpFileName := Nil;
   io.hpInBuffer := Nil;
   io.lpFilterName := Nil;
   io.wFormat := TF_FORMAT_RTF;
   io.bCurSelection := False;
   io.dwBytesReadWritten := 0;
   io.lReserved := 0;
   io.lpFilterIO := Nil;

   if (SendMessage(hWndTx, TX_DATAOUT, 0, lparam(@io)) <> 0) then begin
      p := GlobalLock(io.hOutBuffer);
      TXDataOut := p;
      GlobalUnlock(io.hOutBuffer);
      GlobalFree(io.hOutBuffer);
   end else begin
      TXDataOut := '';
   end;
end; { TXDataOut }

// ----------------------------------------------------------------------------
// TXDataIn
//
// Send the data which is passed in the sData parameter to the Text Control
// specified in hWndTx.
// ----------------------------------------------------------------------------
procedure TXDataIn(hWndTx: HWND; sData: string);
var
   io: TTxDataIO;
begin
   io.wTXVersion := 500;
   io.hFile := HFILE_ERROR;
   io.lpFileName := Nil;
   io.hpInBuffer := pchar(sData);
   io.lpFilterName := Nil;
   io.bCurSelection := False;
   io.dwBytesReadWritten := 0;
   io.lReserved := 0;
   io.lpFilterIO := Nil;
   io.wFormat := TF_FORMAT_RTF;

   if strlcomp(pchar(sData), '{\rtf', 5) = 0 then
      SendMessage(hWndTx, TX_DATAIN, 0, lparam(@io));
      
end; { TXDataIn }

end.
