unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, ExtCtrls, Db, DBTables, OleCtrls, Tx4oleLib_TLB, TxDataIo,
  Menus;

type
  TForm1 = class(TForm)
    TXTextControl1: TTXTextControl;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    Table1: TTable;
    TXButtonBar1: TTXButtonBar;
    procedure FormCreate(Sender: TObject);
    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
    procedure FormResize(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure EnableTextControl(bEnable : Boolean);
begin
   if bEnable then begin
      Form1.TxTextControl1.EditMode := 0; { enable editing }
      Form1.TxButtonBar1.Enabled := True;;
   end
   else begin
      Form1.TxTextControl1.EditMode := 2; { read only }
      Form1.TxButtonBar1.Enabled := False;
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

   { Connect to database }
   Table1.TableName := 'Data.dbf';
   DataSource1.DataSet := Table1;
   Table1.Active := True;
   DBNavigator1.DataSource := DataSource1;

   { Connect Ruler and ButtonBar }
   TxTextControl1.ButtonBarHandle := TXButtonBar1.Handle;

   { Load first record }
    TXDataIn(TxTextControl1.Handle, Table1.Fields[0].AsString);

end;

procedure TForm1.DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
begin
   case Button of

      nbFirst, nbPrior, nbNext, nbLast, nbDelete:
         { Move to another record and load it into the Text Control }
         begin
            TXDataIn(TXTextControl1.Handle, Table1.Fields[0].AsString);
            EnableTextControl(False);
            TXTextControl1.Refresh;
         end;

      nbEdit:
         { Enable editing of current record}
         begin
            EnableTextControl(True);
         end;

      nbInsert:
         { Delete previous contents of Text Control }
         begin
            EnableTextControl(True);
            TxTextControl1.Text := '(new record)';
         end;

      nbPost:
         { Save changes to current record }
         begin
            Table1.Edit;
            Table1.Fields[0].AsString := TXDataOut(TxTextControl1.Handle);
            EnableTextControl(False);
            Table1.Post;
         end;

      nbCancel:
         { Reload the current record from the database }
         begin
            TXDataIn(TxTextControl1.Handle, Table1.Fields[0].AsString);
            EnableTextControl(False);
         end;

     end;
end;


procedure TForm1.FormResize(Sender: TObject);
begin
     TXTextControl1.Height := ClientHeight - DBNavigator1.Height - TXButtonBar1.Height;
     TXTextControl1.Width := ClientWidth;
     DBNavigator1.Width := (ClientWidth div 2);
     DBNavigator1.Top := ClientHeight - DbNavigator1.Height;
end;

end.

