unit Forms1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, OleCtrls, StdCtrls, ComCtrls, Tx4oleLib_TLB;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Load1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Print1: TMenuItem;
    OpenFileDialog: TOpenDialog;
    SaveDialog1: TSaveDialog;
    N2: TMenuItem;
    Exit1: TMenuItem;
    TXTextControl1: TTXTextControl;
    PrintDialog1: TPrintDialog;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TXTextControl1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    Function toTwip(I :Integer): Integer;
  private
    { Private-Deklarationen }
  public

  end;
Const
  FILE_ID = 12345;
  PRINT_MARGIN = 566; // 1 cm
type
    TX_PRO = record
      xPos : Integer;
      yPos : Integer;
      xSize : Integer;
      ySize : Integer;
    end;
type
    FILE_HEADER = record
      lVersion : LongInt;
    end;
var
  Form1: TForm1;
  MaxID : Integer;
  TX: TTXTextControl;
  TXhWnd : TComponent;
  FileID : FILE_HEADER;
  Filename : String;
  TXProp : TX_PRO;

implementation

uses printers;

{$R *.DFM}

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     MaxID := MaxID + 1;
     TX := TTXTextControl.Create(Form1);
     TX.Parent := Form1;
     TX.Top := Y;
     TX.Left := X;
     TX.Width := TXTextControl1.Width;
     TX.Height := TXTextControl1.Height;
     TX.Name := 'TXTextControl' + InttoStr(MaxID);
     TX.SizeMode := 3; // Move- and sizeable
     TX.BringtoFront;
     TX.OnMouseDown := TXTextControl1MouseDown;
end;

procedure TForm1.TXTextControl1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     TTXTextControl(Sender).BringtoFront;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     MaxID := 1;
end;

procedure TForm1.Load1Click(Sender: TObject);
var
    lFilePos : LongInt;
    InpFile    : file of byte;
    bOpen : Boolean;
    i : Integer;
begin
   // Create an "Open File" dialog box
  OpenFileDialog.Title := 'Open file';
  OpenFileDialog.Filename := '';
  OpenFileDialog.Filter := 'TX Form Demo (*.txf)|*.txf';
  OpenFileDialog.FilterIndex := 1;

 if OpenFileDialog.Execute then
   Filename := OpenFileDialog.Filename
 else Exit;

 bOpen := False;
 try
   begin
     // Open the selected file
        AssignFile(inpFile, filename);
        reset(inpFile);
        bOpen := True;

    // Read file header
    BlockRead(inpFile, FileID, sizeOf(FileID));
    If FileID.lVersion <> FILE_ID Then begin
       MessageDlg('Wrong filetype: ' + filename, mtError,[mbOK],0);
       Exit;
    End;

   // Destroy existing controls
   If MaxID > 1 then begin
       For i := 2 To MaxID do
       begin
           TXhWnd := FindComponent('TXTextControl' + Inttostr(i));
           TTXTextControl(TXhWnd).Free;
       end;
   end;

   //Create text controls and load their contents
   BlockRead(InpFile, MaxID, sizeof(MaxID));
   For i := 1 To MaxID do begin
        BlockRead(InpFile, TXProp, sizeof(TXProp));
        If i <> 1 Then begin
                TX := TTXTextControl.Create(Form1);
                TX.Parent := Form1;
                TX.Width := TXTextControl1.Width;
                TX.Height := TXTextControl1.Height;
                TX.Name := 'TXTextControl' + InttoStr(i);
                TX.SizeMode := 3;
                TX.BringtoFront;
                TX.OnMouseDown := TXTextControl1MouseDown;
        end;
        TXhWnd := FindComponent('TXTextControl' + Inttostr(i));
        TTXTextControl(TXhWnd).Left := TXProp.xPos;
        TTXTextControl(TXhWnd).Top := TXProp.yPos;
        TTXTextControl(TXhWnd).Width := TXProp.xSize;
        TTXTextControl(TXhWnd).Height := TXProp.ySize;
        TTXTextControl(TXhWnd).Text := '';
    end;
    lFilePos := FilePos(InpFile);
    closeFile(InpFile);
    bOpen := False;

    For i := 1 To MaxID do begin
        TXhWnd := FindComponent('TXTextControl' + Inttostr(i));
        lFilePos := TTXTextControl(TXhWnd).Load(FileName, lFilePos, 3, False);
        TTXTextControl(TXhWnd).Visible := True;
    end;
   end;
  Except
       MessageDlg('Error opening ' + filename, mtError, [mbOK], 0);
       if bOpen then begin
          closeFile(inpFile);
       end;
    end;

end;

procedure TForm1.Save1Click(Sender: TObject);
var
    outFile    : file of byte;
    i : Integer;
begin
  // Create an "Open File" dialog box
  SaveDialog1.Title := 'Save as';
  SaveDialog1.Filename := '';
  SaveDialog1.DefaultExt := 'txm';
  SaveDialog1.Filter := 'TX Form Demo (*.txf)|*.txf';
  SaveDialog1.FilterIndex := 1;

 if SaveDialog1.Execute then
   Filename := SaveDialog1.Filename
 else
     Exit;

 try
     begin
    // Open the selected file
    AssignFile(outFile, filename);
    rewrite(outFile);
    // Write file header
    FileID.lVersion := File_ID;
    BlockWrite(outFile, FileID, sizeOf(FileID));

   //Save properties of all text controls
   BlockWrite(outFile, MaxID, sizeof(MaxID));
   For i := 1 To MaxID do begin
        TXhWnd := FindComponent('TXTextControl' + Inttostr(i));
        with TXProp do begin
             xPos := TTXTextControl(TXhWnd).Left;
             yPos := TTXTextControl(TXhWnd).Top;
             xSize := TTXTextControl(TXhWnd).Width;
             ySize := TTXTextControl(TXhWnd).Height;
        end;
        BlockWrite(outFile, TXProp, sizeof(TXProp));
    end;
    closeFile(outFile);

    //Save contents of all text controls
    For i := 1 to MaxID do begin
        TXhWnd := FindComponent('TXTextControl' + InttoStr(i));
        TTXTextControl(TXhWnd).Save(FileName, -1, 3, False);
        end;
   end;
  Except
       MessageDlg('Error saving ' + filename, mtError, [mbOK], 0);
    end;

end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.Print1Click(Sender: TObject);
var
   i : Integer;
begin
     Printer.BeginDoc;
     For i := 1 To MaxID do begin
         TXhWnd := FindComponent('TXTextControl' + InttoStr(i));
         TTXTextControl(TXhWnd).PrintDevice := Printer.Handle;
         TTXTextControl(TXhWnd).PageMarginL := toTwip(TTXTextControl(TXhWnd).Left);
         TTXTextControl(TXhWnd).PageMarginT := toTwip(TTXTextControl(TXhWnd).Top);
         TTXTextControl(TXhWnd).PrintPage (1);
         end;
     Printer.NewPage;
     Printer.EndDoc;
end;

Function TForm1.toTwip(I :Integer): Integer;
begin
     toTwip := I * (1440 div Form1.PixelsPerInch);
end;

end.
