unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Tx4oleLib_TLB, Unit3;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    txtLinkedText: TEdit;
    txtLinkTarget: TEdit;
    btnOK: TButton;
    btnCancel: TButton;
    procedure btnCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
  private
    { Private declarations }
  public
    tx : TTXTextControl;
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses Unit1;

{$R *.DFM}

procedure TForm2.btnCancelClick(Sender: TObject);
begin
     Close;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
// If the caret is inside an existing hyperlink, copy the hyperlink's text and link
// information to the text boxes on the form.

    If (Form1.TXTextControl1.FieldAtInputPos <> 0) Then  begin
        txtLinkedText.Text := Form1.TXTextControl1.FieldText;
        txtLinkTarget.Text := Form1.TXTextControl1.FieldTypeData[Form1.TXTextControl1.FieldCurrent];
    end Else begin
        txtLinkedText.Text := Form1.TXTextControl1.SelText;
        txtLinkTarget.Text := '';
    end;
end;

procedure TForm2.btnOKClick(Sender: TObject);
begin
    If (txtLinkedText.Text = '') Then
        MessageBox(0, 'Hyperlink contains no text. Please enter the text to be shown as a hyperlink in the Linked Text field.', 'ERROR', MB_OK)
    Else If (txtLinkTarget.Text = '') Then
        MessageBox(0, 'No target specified. Please enter a target URL in the Link To field.', 'ERROR', MB_OK)
    Else begin
        If tx.FieldAtInputPos <> 0 Then begin
            // editing an existing hyperlink
            tx.FieldText := txtLinkedText.Text;
            tx.FieldType[tx.FieldCurrent] := txFieldExternalLink;
            tx.FieldTypeData[tx.FieldCurrent] := txtLinkTarget.Text;
        end Else begin
            // insert new hyperlink
            tx.FieldInsert (txtLinkedText.Text);
            tx.FieldType[tx.FieldCurrent] := txFieldExternalLink;
            tx.FieldTypeData[tx.FieldCurrent] := txtLinkTarget.Text;
            HighlightHyperlinks (tx, Form1.HypertextLinks1.Checked);
        End;
        close;
    End;
end;

end.
