unit MDIFrame;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Buttons, ExtCtrls, OleCtrls, Tx4oleLib_TLB;

type
  TFrameForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    OpenFileDialog: TOpenDialog;
    ColorDialog1: TColorDialog;
    TXButtonBar1: TTXButtonBar;
    TXStatusBar1: TTXStatusBar;
    N2: TMenuItem;
    Aboutthisdemo1: TMenuItem;
    Window1: TMenuItem;
    Cascade1: TMenuItem;
    TileHorizontal1: TMenuItem;
    TileVertical1: TMenuItem;
    Arrange1: TMenuItem;
    ToolPanel: TPanel;
    NewButton: TSpeedButton;
    OpenButton: TSpeedButton;
    SaveButton: TSpeedButton;
    PrintButton: TSpeedButton;
    CutButton: TSpeedButton;
    PasteButton: TSpeedButton;
    CopyButton: TSpeedButton;
    procedure Exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure NewButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OpenButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure CutButtonClick(Sender: TObject);
    procedure CopyButtonClick(Sender: TObject);
    procedure PasteButtonClick(Sender: TObject);
    procedure PrintButtonClick(Sender: TObject);
    procedure Aboutthisdemo1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure TileHorizontal1Click(Sender: TObject);
    procedure TileVertical1Click(Sender: TObject);
    procedure Arrange1Click(Sender: TObject);
  private

  public
    CountClients   :  integer;
  end;

var
  FrameForm: TFrameForm;

implementation

uses MDIEdit, FileIO, TXglobal, AboutDlg;

{$R *.DFM}

procedure TFrameForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TFrameForm.New1Click(Sender: TObject);
begin
     Window1.Visible := True;
     TXButtonBar1.Visible := True;
     TXStatusBar1.Visible := True;
     ToolPanel.Visible := True;
     TEditForm.Create(Self);
end;

procedure TFrameForm.Open1Click(Sender: TObject);
var Filename,Check : String;
{-------------------------------------------------------------------------
  This function is called when the user selects the "Open File..." menu
  or the corresponding button in the button bar. The function calls
  the "file open" common dialog box and passes the filename to OpenFile().
 -------------------------------------------------------------------------}
begin
  OpenFileDialog.Title := 'Open file';
  OpenFileDialog.Filename := '';
  OpenFileDialog.Filter := 'Text Control Demo (*.txm)|*.txm|Rich Text Format (*.rtf)|*.rtf|Plain text(*.txt)|*.txt|HTML Format(*.htm), (*.html)|*.htm;*.html|Word Document (*.doc)|*.doc';
  OpenFileDialog.FilterIndex := 1;

 if FrameForm.OpenFileDialog.Execute then begin
  with TEditForm.Create(Self) do begin
   Filename := FrameForm.OpenFileDialog.Filename;
   Check := UpperCase(copy(Filename, length(filename)-2, 3));
   If Check = 'RTF' Then OpenFile(Filename, RTF_FILE, False)
   else If Check = 'HTM' Then OpenFile(Filename, HTM_FILE, False) //Check for .htm or .html
   else If Check = 'TML' Then OpenFile(Filename, HTM_FILE, False) //extension!
   else If Check = 'TXT' Then OpenFile(Filename, TXT_FILE, False)
   else If Check = 'DOC' Then OpenFile(Filename, DOC_FILE, False)
   Else OpenFile(Filename, TXM_FILE, False);
   end;
  end;
end;

procedure TFrameForm.NewButtonClick(Sender: TObject);
begin
  New1Click(Sender);
end;

procedure TFrameForm.FormShow(Sender: TObject);
var x : byte;
begin
  CountClients:=0;
  if ParamCount=0 then begin
     New1Click(SENDER);
  end
  else begin
     for x:=1 to ParamCount do begin
        If UpperCase(copy(ParamStr(x), length(ParamStr(x))-2, 3)) = 'RTF' Then
           OpenFile(ParamStr(x), RTF_FILE, False)
        Else OpenFile(ParamStr(x), TXM_FILE, False);
      end;
   end;
end;

procedure TFrameForm.OpenButtonClick(Sender: TObject);
begin
  Open1Click(Sender);
end;

procedure TFrameForm.SaveButtonClick(Sender: TObject);
begin
  FileSaveProc;
end;

procedure TFrameForm.CutButtonClick(Sender: TObject);
begin
  TEditForm(FrameForm.ActiveMDIChild).Cut1Click(Sender);
end;

procedure TFrameForm.CopyButtonClick(Sender: TObject);
begin
  TEditForm(FrameForm.ActiveMDIChild).Copy1Click(Sender);
end;

procedure TFrameForm.PasteButtonClick(Sender: TObject);
begin
  TEditForm(FrameForm.ActiveMDIChild).Paste1Click(Sender);
end;

procedure TFrameForm.PrintButtonClick(Sender: TObject);
begin
  TEditForm(FrameForm.ActiveMDIChild).Print1Click(Sender);
end;

procedure TFrameForm.Aboutthisdemo1Click(Sender: TObject);
begin
     frmAbout.ShowModal
end;

procedure TFrameForm.Cascade1Click(Sender: TObject);
begin
     Cascade;
end;

procedure TFrameForm.TileHorizontal1Click(Sender: TObject);
begin
     TileMode := tbHorizontal;
     Tile;
end;

procedure TFrameForm.TileVertical1Click(Sender: TObject);
begin
     TileMode := tbVertical;
     Tile;
end;

procedure TFrameForm.Arrange1Click(Sender: TObject);
begin
     ArrangeIcons;
end;

end.
