unit frameAttr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Module1, txglobal, Tx4oleLib_TLB;

type
  TFrameAtt = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    txtNextFrame: TEdit;
    Button2: TButton;
    GroupBox1: TGroupBox;
    cmdCancel: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    txtLeft: TEdit;
    txtTop: TEdit;
    txtWidth: TEdit;
    txtHeight: TEdit;
    Button3: TButton;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    cmbFrameNo: TComboBox;
    procedure cmdCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure cmbFrameNoChange(Sender: TObject);
    procedure DisplayConnections(Sender : TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FrameAtt: TFrameAtt;

implementation

uses main;

{$R *.DFM}

procedure TFrameAtt.cmdCancelClick(Sender: TObject);
begin
     Close;
end;

procedure TFrameAtt.FormShow(Sender: TObject);
begin
     DisplayConnections(Sender);
end;

procedure TFrameAtt.Button2Click(Sender: TObject);
begin
     if (StrtoInt(txtNextFrame.Text) <= doc.nTextControls) then begin
          frmMain.Find('TX', StrtoInt(txtNextFrame.Text));
          frmMain.ConnectFrames(ctrParam, TTXTextControl(TXhWnd));
     end;
end;

procedure TFrameAtt.cmbFrameNoChange(Sender: TObject);
begin
try
     frmMain.Find('TX', StrtoInt(cmbFrameNo.Text));
     ctrParam := TTXTextControl(TXhWnd);
     if (StrtoInt(cmbFrameNo.Text) <= doc.nTextControls) then
          DisplayConnections(Sender);

except
      on EConvertError do ;
end;
end;

procedure TFrameAtt.DisplayConnections(Sender : TObject);
var
   n : Integer;
   hWnd : TComponent;
begin
    If glnMeasurement = M_INCH Then begin
        For n :=7 To 10 do begin
            hWnd := FindComponent('LABEL' + InttoStr(n));
            TLabel(hWnd).Caption := GS_INCH;
        end;
    end
    Else begin
        For n := 7 To 10 do begin
            hWnd := FindComponent('LABEL' + InttoStr(n));
            TLabel(hWnd).Caption := GS_CM;
        End;
    End;

    txtLeft.Text := Twips2DlgString(frmMain.toTwip(ctrParam.left));
    txtTop.Text := Twips2DlgString(frmMain.toTwip(ctrParam.top));
    txtWidth.Text := Twips2DlgString(frmMain.toTwip(ctrParam.Width));
    txtHeight.Text := Twips2DlgString(frmMain.toTwip(ctrParam.Height));

    while(cmbFrameNo.Items.Count <> 0) do
         cmbFrameNo.Items.Delete(0);

    for n:=1 to doc.nTextControls do
        cmbFrameNo.Items.Add(InttoStr(n));

    cmbFrameNo.Text := Copy(ctrParam.Name, 3, Length(ctrParam.Name) - 2);
    cmbFrameNo.Refresh;

    txtNextFrame.Enabled := (doc.nTextControls > 1);

    if ctrParam.NextWindow <> 0 then begin
       for n:=1 to doc.nTextControls do begin
           frmMain.Find('TX', n);
           if(TTXTextControl(TXhWnd).handle = ctrParam.NextWindow) then
                txtNextFrame.Text := InttoStr(n);
       end;
    end
    else
        txtNextFrame.Text := '';
end;

procedure TFrameAtt.Button3Click(Sender: TObject);
begin
    ctrParam.left := frmMain.toPix(DlgString2Twips(txtLeft.Text));
    ctrParam.top := frmMain.toPix(DlgString2Twips(txtTop.Text));
    ctrParam.Width := frmMain.toPix(DlgString2Twips(txtWidth.Text));
    ctrParam.Height := frmMain.toPix(DlgString2Twips(txtHeight.Text));

    frmMain.TX1Size(ctrParam);
end;

end.
